package application;

import java.time.LocalDate;
import java.util.ArrayList;

public class Model {
	
	private ArrayList<Contatto> lista = new ArrayList<Contatto>();
    private int idSelC=-1;
    private int idSelM=-1;
    private int id=0;
    
    public boolean cercaDuplicato(String nome, String cognome){
       	for(Contatto lst :lista){
       		System.out.println("ID: "+lst.getId()+" SEL: "+idSelM);
    		if(lst.getNome().equals(nome) && lst.getCognome().equals(cognome)&&lst.getId()!=idSelM+1){
    			return true;
    		}
    	}
       	return false;
    }
    
    public void nuovoContatto(String nome, String cognome,LocalDate data,String telefono){
		id++;
		Contatto cont = new Contatto(id,nome,cognome,data,telefono);
    	lista.add(cont);
    }
    
    public String cercaContatti(String nome, String cognome,LocalDate data,String tel){
    	String found = "";
    	for(Contatto c : lista){
    		if((nome.isEmpty()||c.getNome().contains(nome))&&
    			(cognome.isEmpty()||c.getCognome().contains(cognome))&&
    			(data==null||c.getDatanasc().equals(data))&&
    			(tel.isEmpty()||c.getTelefono().contains(tel))&&
    			(!nome.isEmpty()||!cognome.isEmpty()||data!=null||!tel.isEmpty())){
    				found += "\n"+"ID: "+c.getId()+"		"+c.getNome()+"		"+c.getCognome()+"	"+c.getDatanasc()+"		"+c.getTelefono();
    		}
    	}
    	return found;
    }
    
    public Contatto cercaIdModifica(int id){
    	Contatto cont = null;
    	for(Contatto c : lista){
    		if(c.getId() == id){
    			idSelM=lista.indexOf(c);
    			cont = new Contatto(id,c.getNome(),c.getCognome(),c.getDatanasc(),c.getTelefono());
    			return cont;
			}
    	}
    	return cont;
    }
    
    public Contatto cercaIdCancella(int id){
    	Contatto cont = null;
    	for(Contatto c : lista){
    		if(c.getId() == id){
    			idSelC=lista.indexOf(c);
    			cont = new Contatto(id,c.getNome(),c.getCognome(),c.getDatanasc(),c.getTelefono());
    			return cont;
			}
    	}
    	return cont;
    }
    
    public boolean isModificabile(){
    	if(idSelM==-1) return false;
    	else return true;
    }

    public boolean isCancellabile(){
    	if(idSelC==-1) return false;
    	else return true;
    }
    
    public void applicaModifica(String nome, String cognome,LocalDate data,String tel){
    	Contatto cont = lista.get(idSelM);
		cont.setNome(nome);
		cont.setCognome(cognome);
		cont.setDatanasc(data);
		cont.setTelefono(tel);
		idSelM = -1;
    }
    
    public void applicaCancella(){
    	lista.remove(idSelC);
		idSelC = -1;	    	
    }
    
}
