/**
 * Sample Skeleton for "Impicc.fxml" Controller Class
 * You can copy and paste this code into your favorite IDE
 **/

package application;

import java.time.LocalDate;

import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.DatePicker;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;


public class RubrController {
	
	private Model model ;

	@FXML 
    private TextField nomeText; // Value injected by FXMLLoader
    @FXML
    private TextField cognomeText; // Value injected by FXMLLoader
    @FXML
    private DatePicker datanascText; // Value injected by FXMLLoader
    @FXML
    private TextField telefonoText; // Value injected by FXMLLoader
    @FXML
    private TextField idMod; // Value injected by FXMLLoader
    @FXML
    private TextField idCanc; // Value injected by FXMLLoader

    
      
    @FXML
    private Button inserisciBtn;
    @FXML
    private Button ricerceBtn;
    @FXML
    private Button modificaBtn;
    @FXML
    private Button applicaMBtn;
    @FXML
    private Button cancellaBtn;
    @FXML
    private Button applicaCBtn;
    
    @FXML
    private TextArea result;
    

    @FXML 
    void inserisci() {
    	if(nomeText.getText().isEmpty()||cognomeText.getText().isEmpty()||datanascText.getValue()==null ||telefonoText.getText().isEmpty()){
    		result.setText("Errore: devi riempire tutti i campi del form, fatta eccezione per l'ID");
    		return;
    	}
    	
    	if(model.cercaDuplicato(nomeText.getText(),cognomeText.getText())){    	
    			result.setText("Errore: il contatto inserito esiste già");
    			return;
    	}
    	model.nuovoContatto(nomeText.getText(),cognomeText.getText(),datanascText.getValue(),telefonoText.getText());
    	result.setText("Il contatto è stato inserito correttamente");
    }
    
    @FXML 
    void ricerca() {
    	String nome;
    	String cognome;
    	LocalDate data;
    	String tel;

    	nome =nomeText.getText();
		cognome =cognomeText.getText();
		data = datanascText.getValue();
		tel = telefonoText.getText();
    			
		result.setText("Risultato della ricerca: \n"+model.cercaContatti(nome,cognome,data,tel));  			
    	
    }

    @FXML 
    void modifica() {
    	if(!idMod.getText().isEmpty()){
    		Contatto c = model.cercaIdModifica(Integer.parseInt(idMod.getText()));
    		if(c!=null){
				nomeText.setText(c.getNome());
    			cognomeText.setText(c.getCognome());
    			datanascText.setValue(c.getDatanasc());
    			telefonoText.setText(c.getTelefono());
    			result.setText("Per confermare la modifica premere \"applica\"");
    			return;
    		}
    	}
    	result.setText("Inserisci un ID valido");
    }

    @FXML 
    void applicaM() {
    	if(model.isModificabile()) {
    		if(nomeText.getText().isEmpty()||cognomeText.getText().isEmpty()||datanascText.getValue()==null ||telefonoText.getText().isEmpty()){
        		result.setText("Errore: non puoi lasciare campi vuoti");
        		return;
        	}
        	
    		if(model.cercaDuplicato(nomeText.getText(),cognomeText.getText())){    	
    			result.setText("Errore: il contatto inserito esiste già");
    			return;
    		}
    		
    		model.applicaModifica(nomeText.getText(),cognomeText.getText(),datanascText.getValue(),telefonoText.getText());
    		result.setText("La modifica è andata a buon fine");
    	}else{
    		result.setText("Devi prima premere il tasto modifica");
    	}
    }

    @FXML 
    void cancella() {
    	
		if(!idCanc.getText().isEmpty()){
			Contatto c = model.cercaIdCancella(Integer.parseInt(idCanc.getText()));
				if(c!=null){
					nomeText.setText(c.getNome());
	    			cognomeText.setText(c.getCognome());
	    			datanascText.setValue(c.getDatanasc());
	    			telefonoText.setText(c.getTelefono());
	    			result.setText("Per confermare la cancellazione premere \"applica\"");
	    			return;
				}
	    	}
	    	result.setText("Inserisci un ID valido");
    }

    @FXML 
    void applicaC() {
    	if(model.isCancellabile()) {
    		model.applicaCancella();
    		result.setText("La cancellazione è andata a buon fine");
    	}else{
    		result.setText("Devi prima premere il tasto cancella");
    	}
    }


	public Model getModel() {
		return model;
	}


	public void setModel(Model model) {
		this.model = model;
		
	}
	

}
